package com.ims.eval.service;

import com.baomidou.mybatisplus.core.metadata.IPage;
import com.ims.eval.entity.OrganizationEvaluation;
import com.baomidou.mybatisplus.extension.service.IService;
import com.ims.eval.entity.dto.response.OrganizationEvaluationResDTO;
import com.ims.eval.entity.dto.result.R;
import org.springframework.transaction.annotation.Transactional;

import javax.servlet.http.HttpServletRequest;
import java.util.List;
import java.util.Map;

/**
 * <p>
 * 单位/部门考评记录 服务类
 * </p>
 *
 * @author wang
 * @since 2023-03-16
 */
public interface IOrganizationEvaluationService extends IService<OrganizationEvaluation> {

	IPage<OrganizationEvaluation> list(Integer pageNum, Integer pageSize, String id, String organizationEvaluationCode, List<String> checkCycle, String beginDate, String endDate, String stage, String createBy, String year, String month, String des);


	@Transactional
	R generateUnitEvaluationInfo(List<String> ids,String indicatorId,String organizationId,Boolean mark);


	@Transactional
	R generateUnitMonthEvaluation(List<String> ids, String indicatorId, String organizationId, Boolean mark);

	@Transactional
	boolean generateUnitSeasonEvaluation(List<String> ids);


	List<OrganizationEvaluation> list(String organizationId, String checkCycle, String year, String month);


	boolean editState(String id, String state,String instId);


	OrganizationEvaluationResDTO getByidAndInfo(String id, String dept,HttpServletRequest request);


	List<Map<String, Object>> getCompanyWarning(String evaluationType);


	Map getEvaluationScoreInfo(String id,String  binSection,String indicatorId,String  organizationEvaluationRuleId);


	OrganizationEvaluation getOrganizationEvaluation(String id);
}
